#include <cstdlib>
#include "string.h"

String::String() : sz(0), letters(NULL)
{
}

String::String(const String& org) : sz(org.sz), letters(NULL)
{
	if(sz!=0) {
		letters = new char[sz];
		for(unsigned int i=0; i<sz; ++i) {
			letters[i] = org.letters[i];
		}
	}
}

String::~String()
{
	if(0!=sz) {
		delete [] letters;
	}
}

String::String(const char* val) : sz(0)
{
	letters = NULL;
	while(val[sz]!='\0') {
		++sz;
	}
	if(sz!=0) {
		letters = new char[sz];
		for(unsigned int i=0; i<sz; ++i) {
			letters[i] = val[i];
		}
	}
}

String& String::operator=(const String& rhs)
{
	// Check for self-assignment
	if(&rhs!=this) {
		if(sz!=0) {
			delete [] letters;
		}
		sz = rhs.sz;
		if(sz!=0) {
			letters = new char[sz];
			for(unsigned int i=0; i<sz; ++i) {
				letters[i] = rhs.letters[i];
			}
		} else {
			letters = NULL;
		}
	}
	return *this;
}

unsigned int String::size() const
{
	return sz;
}

const char& String::operator[](unsigned int index) const
{
	return letters[index];
}

char& String::operator[](unsigned int index)
{
	return letters[index];
}

String operator+(const String& lhs, const String& rhs)
{
	return lhs.add(rhs);
}


